 /*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

 
#ifndef _OVLFCME_H_
#define _OVLFCME_H_ 1

/*
 * Data sturcture for vfGetVideoFormat_CME()
 */
typedef struct _VIDGETFORMAT
{
    /* Input data */
    unsigned long           dwVideoFlag;
    unsigned long           dwCtlHQVflag;
    LPDDPIXELFORMAT         lpDPFsrc;
    unsigned long           dwDisplayPictStruct;
    unsigned long           dwDeinterlaceMode;
    unsigned long           dwMPEGProgressiveMode;
    unsigned long           dwMPEGInTVFullScreen;
    unsigned long           dwVDevFlag;             /* CTL_UseDualView 0x00000001 */
                                            /*  CTL_UseDuoView  0x00000002 */
                                            /* CTL_UseIGA2Path 0x00000004 */
    /* Output data */
    unsigned long*         lpdwVidCtl;
    unsigned long*         lpdwHQVCtl;
}VIDGETFORMAT,*PVIDGETFORMAT;

/*
 * Data sturcture for vfGetSrcStartAddress_CME()
 */
typedef struct _VIDGETSRCADDR
{
    /* Input data */
    unsigned long           dwVideoFlag;
    unsigned long           dwCtlHQVflag;
    LPDDPIXELFORMAT lpDPFsrc;
    unsigned long           dwSrcPitch;
    OV_RECTL           rSrc;
    OV_RECTL           rDest;
    PVIDDEVICEINFO  pVDevInfo;
    /* Output data */
    unsigned long*         lpdwOffset;
    unsigned long*         lpVideoSrcOffset;
}VIDGETSRCADDR,*PVIDGETSRCADDR;

/*
 * Data sturcture for vfGetFetch_CME()
 */
typedef struct _VIDGETFETCH
{
    /* Input data */
    unsigned long           dwVideoFlag;
    unsigned long           dwCtlHQVflag;
    LPDDPIXELFORMAT lpDPFsrc;
    unsigned long           dwSrcWidth;
    unsigned long           dwDstWidth;
    unsigned long           dwOriSrcWidth;
    /* Output data */
    unsigned long*         lpdwFetch;
    unsigned long*         lpdwHQVsrcFetch;    
}VIDGETFETCH,*PVIDGETFETCH;


/*
 * Data sturcture for vfCalcZoomWidth_CME()
 */
typedef struct _VIDCALCZOOMW
{
    /* Input data */
    unsigned long           dwCtlHQVflag;
    unsigned long           dwSrcWidth;
    unsigned long           dwDstWidth;
    /* Output data */
    unsigned long*         lpdwZoomCtl;
    unsigned long*         lpdwMiniCtl;    
    unsigned long*         lpdwHQVminiCtl;    
    unsigned long*         lpdwHQVzoomflagH;    
    unsigned long*         lpdwMiniHFactor;    /* For Video without HQV */
    unsigned long*         lpdwFetchAlignment; /* For Video without HQV */

    unsigned long *        lpdwHQVScaleCtlH;  /* For 3293, not use lpdwHQVminiCtl;*/

}VIDCALCZOOMW,*PVIDCALCZOOMW;

/*
 * Data sturcture for vfCalcZoomHeight_CME()
 */
typedef struct _VIDCALCZOOMH
{
    /* Input data */
    unsigned long           dwCtlHQVflag;
    unsigned long           dwSrcHeight;
    unsigned long           dwDstHeight;
    /* Output data */
    unsigned long*         lpdwZoomCtl;
    unsigned long*         lpdwMiniCtl;    
    unsigned long*         lpdwHQVminiCtl;    
    unsigned long*         lpdwHQVzoomflagV;   
    
    unsigned long *        lpdwHQVScaleCtlV;  /* For 3293, not use lpdwHQVminiCtl;*/
}VIDCALCZOOMH,*PVIDCALCZOOMH;


/*
 * Data sturcture for vfGetDisplayCount_CME()
 */
typedef struct _VIDGETDISPLAYCOUNT
{
    /* Input data */
    unsigned long           dwVideoFlag;
    LPDDPIXELFORMAT lpDPFsrc;
    unsigned long           dwSrcWidth;
    unsigned long           dwMiniHFactor;
    /* Output data */
    unsigned long*         lpdwDisplayCountW;
}VIDGETDISPLAYCOUNT,*PVIDGETDISPLAYCOUNT;


/*
 * Data sturcture for vfSetHQVTileModeAndCSCcontrol_CME()
 */
typedef struct _VIDSETTILEANDCSC
{
    /* Input data */
    unsigned long           dwCtlHQVflag;
    unsigned long           dwTCGDRegVal;   /* 0x3DC,HQV Tile/CSC register value */
    unsigned long           dwHQVDstAddr0;  /* 0x3EC,HQV Dest Address 0 register value */
    unsigned long           dwHQVDstAddr1;  /* 0x3F0,HQV Dest Address 1 register value */
    unsigned long           dwOriSrcWidth;
    unsigned long           dwOriSrcHeight;
    unsigned long           dwUseCSC;
    unsigned long           dwFourCC;
    /* Output data */
    unsigned long*          lpdwHQVTileCSCVal;
    unsigned long           dwHQVDstAddr0Val;
    unsigned long           dwHQVDstAddr1val;
}VIDSETTILEANDCSC,*PVIDSETTILEANDCSC;


/*
 * Data sturcture for vfSetHQVDeinterlaceControl_CME()
 */
typedef struct _VIDSETDEINTERLACE
{
    /* Input data */
    unsigned long           dwCtlHQVflag;
    /* Output data */
    unsigned long*         lpdwHQVDeinterlaceVal;
}VIDSETDEINTERLACE,*PVIDSETDEINTERLACE;


/*
 * Data sturcture for vfGetHQVSourceOffset_CME()
 */
typedef struct _VIDGETHQVSRCOFFSET
{
    /* Input data */
    OV_RECTL           rSrc;
    OV_RECTL           rDest;
    LPDDPIXELFORMAT lpDPFsrc;
    /* Output data */
    unsigned long*         lpdwHQVOffset;
    unsigned long*         lpdwHQVSrcDataOffsetStart;
    unsigned long*         lpdwHQVSrcDataOffsetEnd;  
}VIDGETHQVSRCOFFSET,*PVIDGETHQVSRCOFFSET;


/*
 * Data sturcture for vfTVFlickerFilterControl()
 */
typedef struct _VIDTVFILTER
{
    /* Input data */
    PVIDDEVICEINFO  pVDevInfo;
    OV_RECTL           dwOriSrcRect;           /* DDraw source RECTL */
    OV_RECTL           dwOriDestRect;          /* DDRAW destination RECTL */
    unsigned long           dwMPEGInTVFullScreen;
    unsigned long           dwDisableTVFlicker;
    /* Output data */
    unsigned long*         lpdwMPEGInTVFullScreen;
    /* For WinMe TV Flicker Filter tunning when playing Full screen DVD in TV. */
    unsigned char*           pfTV_Optimize_forDVDFS;
}VIDTVFILTER,*PVIDTVFILTER;

/* FUNCTION  DECLARATION ----------------------------------- */
void vfGetVideoFormat_CME(PVIDGETFORMAT pData);
void vfGetSrcStartAddress_CME(PVIDGETSRCADDR pData);
void vfGetFetch_CME(PVIDGETFETCH pData);
unsigned long vfCalcZoomWidth_CME(PVIDCALCZOOMW pData);
unsigned long vfCalcZoomHeight_CME(PVIDCALCZOOMH pData);
void vfGetDisplayCount_CME(PVIDGETDISPLAYCOUNT pData);
void vfTVFlickerFilterControl_CME(PVIDTVFILTER pData);

unsigned long vfCalcZoomWidth_CME_293(PVIDCALCZOOMW pData);
unsigned long vfCalcZoomHeight_CME_293(PVIDCALCZOOMH pData);
void vfGetHQVSourceOffset_CME(PVIDGETHQVSRCOFFSET pData);
void vfSetHQVDeinterlaceControl_CME(PVIDSETDEINTERLACE pData);
void vfSetHQVTileModeAndCSCcontrol_CME(PVIDSETTILEANDCSC pData);
void vfGetHQVSrcDataOffset_CME(PVIDGETHQVSRCOFFSET pData);

#endif /* _OVLFCME_H_ */
