 /*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

 
/* this file is created for video agp command*/
/* I N C L U D E S -------------------------------------------------------*/

#include <asm/mtrr.h>
#include "agpgart.h"

#ifdef XFree86Server 
#include "xf86_ansic.h" /* for Bool */
#include "xf86_libc.h"
#include  "xf86_OSproc.h"
#else
#include "via_types.h"  /* for Bool */
#include <stdlib.h>
#include <stdio.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <sys/time.h>
#include <errno.h>
#endif



#include "debug.h"
#include "agpctl.h"
#include "vdefCME.h"
#include "vregCME.h"

#include "drm.h"
#include "via_drm.h"
#include "via.h"

/* D E F I N E -----------------------------------------------------------*/

#define AGP_PAGES 8192
unsigned long   pVia_agpAddr=(unsigned long)NULL;
unsigned long agpgartLinearStart=(unsigned long)NULL;
int gartFd = -1;
int agpgartkey;
int mtrr;



/* G L O B A L S --------------------------------------------------------*/
drm_via_info_t drm_info;
drm_via_mem_t fb;

/* F U N C T I O N  D E C L A R A T I O N --------------------------------*/
void vfFireAGPcommand(PVIDDATA pVidData);

/*E X T E R N   G L O B A L S----------------------------------------------*/
extern int drm_fd;
extern unsigned int ddmpeg_drm_ctx;
extern unsigned char *pjVideo;
/* E X T E R N   F U N C T I O N S----------------------------------------*/
extern void SwapAGPCmd_DB(LPWKNAGPCMDBUFCONTROL pAGP,PVIDDATA pVidData);
extern void SwapAGPCmd_Ring(LPWKNAGPCMDBUFCONTROL pAGP,PVIDDATA pVidData);
extern void SwapAGPCmd_Null(LPWKNAGPCMDBUFCONTROL pAGP,PVIDDATA pVidData);
extern void SwapAGPCmd_DRM(LPWKNAGPCMDBUFCONTROL pAGP,PVIDDATA pVidData);
extern unsigned long RequestAGPCmdBufSize(PVIDDATA pVidData,LPWKNAGPCMDBUFCONTROL pAGP, unsigned long dwBytes);
extern void DDDecVIDEOAGPCount(PVIDDATA pVidData);
extern void DDIncVIDEOAGPCount(PVIDDATA pVidData);

unsigned long  gdwAGPBaseVirtual= -1, gdwOrigAGPBaseVirtual = 0;
unsigned char   *gpMMIOBase=NULL;
unsigned char   *gpHWAGPCur=NULL;
drm_via_mem_t AgpMem;

WKNAGPCMDBUFCONTROL       ddAGP;
LPWKNAGPCMDBUFCONTROL       pddAGP=&ddAGP;

WKNAGPCONTROL             WknAGP;
LPWKNAGPCONTROL             pWknAGP=&WknAGP;

FPSWAPAGPCOMMAND            fpSwapAGPCmdBuffer;

/* F U N C T I O N -------------------------------------------------------*/

/****************************************************************************
 * VIDEO/MPEG AGP COMMADN FUNCTIONS
 ***************************************************************************/
void VIAInitialize3DEngineForFBAGP(PVIDDATA pVidData)
{
    int i;
    unsigned char* pjVideo = pVidData->Vhwinfo.pjVideo;
    static     Bool b3DRegsInitialized=0;
    

    if (!b3DRegsInitialized)
    {
        dMMWR(pjVideo,0x43C, 0x00010000);

        for (i = 0; i <= 0x7D; i++)
        {
            dMMWR(pjVideo,0x440, (CARD32) i << 24);
        }

        dMMWR(pjVideo,0x43C, 0x00020000);

        for (i = 0; i <= 0x94; i++)
        {
            dMMWR(pjVideo,0x440, (CARD32) i << 24);
        }

        dMMWR(pjVideo,0x440, 0x82400000);
        dMMWR(pjVideo,0x43C, 0x01020000);

        for (i = 0; i <= 0x94; i++)
        {
            dMMWR(pjVideo,0x440, (CARD32) i << 24);
        }

        dMMWR(pjVideo,0x440, 0x82400000);
        dMMWR(pjVideo,0x43C, 0xfe020000);

        for (i = 0; i <= 0x03; i++)
        {
            dMMWR(pjVideo,0x440, (CARD32) i << 24);
        }

        dMMWR(pjVideo,0x43C, 0x00030000);

        for (i = 0; i <= 0xff; i++)
        {
            dMMWR(pjVideo,0x440, 0);
        }
        dMMWR(pjVideo,0x43C, 0x00100000);
        dMMWR(pjVideo,0x440, 0x00333004);
        dMMWR(pjVideo,0x440, 0x10000002);
        dMMWR(pjVideo,0x440, 0x60000000);
        dMMWR(pjVideo,0x440, 0x61000000);
        dMMWR(pjVideo,0x440, 0x62000000);
        dMMWR(pjVideo,0x440, 0x63000000);
        dMMWR(pjVideo,0x440, 0x64000000);
        dMMWR(pjVideo,0x43C, 0x00fe0000);

        if (pVidData->VIAGraphicInfo.dwRevisionID >= 3 )
            dMMWR(pjVideo,0x440,0x40008c0f);
        else
            dMMWR(pjVideo,0x440,0x4000800f);

        dMMWR(pjVideo,0x440,0x44000000);
        dMMWR(pjVideo,0x440,0x45080C04);
        dMMWR(pjVideo,0x440,0x46800408);
        dMMWR(pjVideo,0x440,0x50000000);
        dMMWR(pjVideo,0x440,0x51000000);
        dMMWR(pjVideo,0x440,0x52000000);
        dMMWR(pjVideo,0x440,0x53000000);

        b3DRegsInitialized = 1;
        DBG_DD(("3D Engine has been initilized.\n"));
    }

    dMMWR(pjVideo,0x43C,0x00fe0000);
    dMMWR(pjVideo,0x440,0x08000001);
    dMMWR(pjVideo,0x440,0x0A000183);
    dMMWR(pjVideo,0x440,0x0B00019F);
    dMMWR(pjVideo,0x440,0x0C00018B);
    dMMWR(pjVideo,0x440,0x0D00019B);
    dMMWR(pjVideo,0x440,0x0E000000);
    dMMWR(pjVideo,0x440,0x0F000000);
    dMMWR(pjVideo,0x440,0x10000000);
    dMMWR(pjVideo,0x440,0x11000000);
    dMMWR(pjVideo,0x440,0x20000000);
}

void openmtrr(void) 
{
    if ((mtrr = open("/proc/mtrr", O_WRONLY, 0)) == -1) 
    {
        if (errno == ENOENT) 
        {
	        perror("/proc/mtrr not found: MTRR not enabled\n");
	    }  
	    else 
	    {
            perror("Error opening /proc/mtrr:");
            perror("MTRR not enabled\n");
            exit(1);
	    }
	    return;
    }
}

int CoverRangeWithMTRR( int base, int range, int type )
{
    /* set it if we aren't just checking the number */
    if ( type != -1 ) 
    {
        struct mtrr_sentry sentry;
      
        sentry.base = base;
        sentry.size = range;
        sentry.type = type;
      
        if ( ioctl(mtrr, MTRRIOC_ADD_ENTRY, &sentry) == -1 ) 
        {
            perror("mtrr");
            exit(1);
        }
    }
    return 0; 
}


int open_init_agpgart(void)
{
    agp_setup setup;
    agp_info agpinfo;

	if ((gartFd = open("/dev/agpgart", O_RDWR))<0)         		
 	{
        DBG_DD(("Open agp gart failed\n"));
        return FALSE;
 	}
 	else 
 	    DBG_DD(("Open agp gart ok,gartFd=%d\n",gartFd));
 
 	if (ioctl(gartFd, AGPIOC_ACQUIRE, 0) != 0) 
 	{
 		DBG_DD(("AcquireGART: AGPIOC_ACQUIRE failed \n"));
 		return FALSE;
 	}
 	else 
 	    DBG_DD(("AcquireGART: AGPIOC_ACQUIRE ok \n"));
         
    if (ioctl(gartFd, AGPIOC_INFO, &agpinfo) != 0)
    {
        DBG_DD(("GARTInit: AGPIOC_INFO failed \n"));
        close(gartFd);
        gartFd = -1;
        return FALSE;
    }
    else 
        DBG_DD(("GARTInit: AGPIOC_INFO ok \n"));
       	   
    openmtrr();
    if (mtrr != -1) 
    { 
        CoverRangeWithMTRR(agpinfo.aper_base, agpinfo.aper_size * 0x100000, MTRR_TYPE_WRCOMB);
    }

    setup.agp_mode = agpinfo.agp_mode;
    DBG_DD(("Using AGPIOC_SETUP\n"));
    if(ioctl(gartFd, AGPIOC_SETUP, &setup) != 0)
    {
        DBG_DD(("ioctl(AGPIOC_SETUP) fail \n"));
        return FALSE;
    }
   
    return TRUE;
}

int insert_gart(int page, int size)
{
    agp_allocate entry;
    agp_bind bind;

    entry.type = 0;
    entry.pg_count = size;

    DBG_DD(("Using AGPIOC_ALLOCATE\n"));

    if(ioctl(gartFd, AGPIOC_ALLOCATE, &entry) != 0)
    {
        DBG_DD(("ioctl(AGPIOC_ALLOCATE) fail\n"));
        return 0;
    }
   	
    bind.key = entry.key;
    bind.pg_start = page;
    DBG_DD(("Using AGPIOC_BIND\n"));

    if(ioctl(gartFd, AGPIOC_BIND, &bind))
    {
        DBG_DD(("ioctl(AGPIOC_BIND) fail\n"));
        return 0;
    }

    DBG_DD(("entry.key : %d entry.physical=0x%x\n", entry.key,entry.physical));

    return(entry.key);
}

int remove_gart(int key)
{
    DBG_DD(("Using AGPIOC_DEALLOCATE\n"));

#ifdef __linux__
    if(ioctl(gartFd, AGPIOC_DEALLOCATE, (int *)key) != 0)
#else
    if(ioctl(gartFd, AGPIOC_DEALLOCATE, &key) != 0)
#endif
    {
        DBG_DD(("ioctl(GARTIOCREMOVE)"));
        return 0;
    }
   
    return(0);
}

int initAGPCmdBufFBwithoutDRM()
{ 
    agp_info info;
	   
    DBG_DD(("Test AGP under fb without drm\n"));  

    if (!open_init_agpgart()) 
        return FALSE;
    agpgartkey=insert_gart(0, AGP_PAGES);       	   
           
    DBG_DD(("Using AGPIOC_INFO\n"));           	   
    if(ioctl(gartFd, AGPIOC_INFO, &info) != 0)
    {
        DBG_DD(("ioctl(AGPIOC_INFO) fail"));
        return FALSE;
    }
    pVia_agpAddr = info.aper_base;
    DBG_DD(("[no drm] agp info.aper_size = %d\n", info.aper_size));

    agpgartLinearStart=(unsigned long )mmap(0, info.aper_size*0x100000, PROT_READ|PROT_WRITE, MAP_SHARED, gartFd, 0);

    DBG_DD(("[no drm] agpAddr = 0x%08lx\n", pVia_agpAddr));

    return TRUE;
}

int DDInitialAGPControl (PVIDDATA pVidData)
{
    LPVIAGRAPHICINFO lpVIAGraphicInfo = &(pVidData->VIAGraphicInfo);
    DBG_DD(("\n"));
    
    /*Add play mpeg2/4 with AGPgart under FB*/
    if(!lpVIAGraphicInfo->dwXServerEnabled) 
    {
        VIAInitialize3DEngineForFBAGP(pVidData);
        if (!initAGPCmdBufFBwithoutDRM()) return FALSE;               

        pddAGP->AGPBasePHYSADD = pVia_agpAddr;

        /* to get the linear address for agp in user space */
        gdwAGPBaseVirtual=agpgartLinearStart;

        if( agpgartLinearStart == -1 )
        {
            pddAGP->dwCmdBufType = AGPCMDBUF_DISABLE; 
            return FALSE;
        }
        DBG_DD(("agpPhysical=%p,agpLinear=%p\n",pddAGP->AGPBasePHYSADD,gdwAGPBaseVirtual));
    }
    else if (drm_fd>0)         
    {
        ioctl(drm_fd,DRM_IOCTL_VIA_GET_INFO,&drm_info); 
        
        AgpMem.size = MPEG_AGP_CMDBUF_SIZE;
        AgpMem.context = 1;
        AgpMem.type = AGP;
        AgpMem.index = 0;
        AgpMem.offset = 0; 
        if(ioctl(drm_fd,DRM_IOCTL_VIA_ALLOCMEM,&AgpMem) == 0)
        {
            /* to get the linear address for agp in user space */
            gdwAGPBaseVirtual =(unsigned long )mmap(0, drm_info.AgpSize, PROT_READ|PROT_WRITE, MAP_SHARED, drm_fd, drm_info.AgpHandle);
            if(gdwAGPBaseVirtual == -1 )                
            {
                pddAGP->dwCmdBufType = AGPCMDBUF_DISABLE; /*  PCI command*/
                return FALSE;
            }
            gdwOrigAGPBaseVirtual = gdwAGPBaseVirtual;
            gdwAGPBaseVirtual += AgpMem.offset;
            pddAGP->AGPBasePHYSADD = drm_info.AgpHandle + AgpMem.offset;
        }
        else return FALSE;
            
        DBG_DD(("drm_info.AgpSize=0x%x drm_info.AgpHandle=0x%x\n",drm_info.AgpSize,drm_info.AgpHandle));
        DBG_DD(("agpPhysical=%p,agpLinear=%p\n",pddAGP->AGPBasePHYSADD,gdwAGPBaseVirtual));
    }
    else   
        return FALSE;
         
    DBG_DD(("1 pWknAGP->dwFlag=%x\n", pWknAGP->dwFlag));
    gpMMIOBase = pjVideo; 	
    if (!(pWknAGP->dwFlag&AGP_DD_INITIALIZED))   
    {
        DBG_DD(("11 pWknAGP->dwFlag=%x\n", pWknAGP->dwFlag));
        pddAGP->dwCmdBufSize = MPEG_AGP_CMDBUF_SIZE;           
        pddAGP->dwCmdBufBegin = 0;
        pddAGP->dwCmdBufEnd = pddAGP->dwCmdBufBegin+ MPEG_AGP_CMDBUF_SIZE - 1;	   
        pddAGP->BufRec[0].Start_pointer = pddAGP->dwCmdBufBegin;
        pddAGP->BufRec[0].End_pointer = pddAGP->BufRec[0].Start_pointer + MPEG_AGP_CMDBUF_SIZE/2-1;
        pddAGP->BufRec[1].Start_pointer = pddAGP->BufRec[0].End_pointer + 1;
        pddAGP->BufRec[1].End_pointer = pddAGP->BufRec[1].Start_pointer + MPEG_AGP_CMDBUF_SIZE/2 -1 ;
    }
           
    switch (lpVIAGraphicInfo->dwDeviceID)
    {
    case VIA_DEVICE_CLE2:/*DEVICE_VT3123*/
        gpHWAGPCur = gpMMIOBase + HC_REG_AGP_CUR;
        pddAGP->dwHWCaps = 0;
        break;
    case VIA_DEVICE_VT3205:
        gpHWAGPCur = gpMMIOBase + VT3205_REG_AGP_CUR;
        pddAGP->dwHWCaps = CAPS_AGPCMD_RING_3205;
        break;
    case VIA_DEVICE_VT3204:
        gpHWAGPCur = gpMMIOBase + VT3205_REG_AGP_CUR;
        pddAGP->dwHWCaps = CAPS_AGPCMD_RING_3204;
        break;
    case VIA_DEVICE_VT3259:
    case VIA_DEVICE_VT3324: 
    case VIA_DEVICE_VT3293:
    case VIA_DEVICE_VT3353:
        gpHWAGPCur = gpMMIOBase + HC_REG_AGP_CUR;/*VT3205_REG_AGP_CUR*/
        pddAGP->dwHWCaps = CAPS_AGPCMD_RING_3204 | CAPS_AGPCMD_RING_3259;
        break;
    case VIA_DEVICE_VT3314:
        gpHWAGPCur = gpMMIOBase + VT3205_REG_AGP_CUR;
        pddAGP->dwHWCaps = CAPS_AGPCMD_RING_3204;
        break;        
    }	
	
    DBG_DD(("2 pWknAGP->dwFlag=%x\n", pWknAGP->dwFlag));
    if (!(pWknAGP->dwFlag&AGP_DD_INITIALIZED))  
    {
        DBG_DD(("21 pWknAGP->dwFlag=%x\n", pWknAGP->dwFlag));
        pddAGP->dwFlag |= AGPSTATUS_CMDBUF_ALLOCATED | AGPSTATUS_BUFTYPE_CHANGE;
        pddAGP->dwCmdBufType  = AGPCMDBUF_DISABLE; 

        pVidData->VidAGPCtl.dwAGPCMCount=0;
        pVidData->VidAGPCtl.dwAGPHeaderType=VIDEO_AGPHeader7;
        pVidData->VidAGPCtl.dwAGPH5Reg=REG_VIDEO_NULL_12A0; /*Null video reg*/
        pVidData->VidAGPCtl.lpAGPSt_buffer = NULL;      
        pVidData->VidAGPCtl.lpAGPCurr_buffer=NULL;    
        pVidData->VidAGPCtl.dwAGPSt_Pointer=0;
        pVidData->VidAGPCtl.dwAGPCurr_Pointer = 0;

        if(!(drm_fd > 0))
        {
            unsigned long   dwSWCurPointer;
            unsigned long   dwQWDummy;
            unsigned long   dwBstL,dwBendL,dwCMNT,dwBpL,dwBpH;
            unsigned long   dwStart, dwEnd, dwPause;
                            
            dwSWCurPointer = gdwAGPBaseVirtual;
            /* add dummy command once AGP allocate*/
            *(unsigned long *)dwSWCurPointer = (0xF2000000 | ((0x43C >> 2) << 12) | (0x440 >> 2));
            dwSWCurPointer += 4;
            *(unsigned long *)dwSWCurPointer = 0x00100000;
            dwSWCurPointer += 4;
            /* made 32 QDword alignment */
            dwQWDummy = 32 - (((dwSWCurPointer) & 0xff) >> 3);
            for (;dwQWDummy > 0; dwQWDummy--)
            {
                *(unsigned long *)dwSWCurPointer = 0xCC000000;
                dwSWCurPointer += 4;
                *(unsigned long *)dwSWCurPointer = 0xDDD00000;
                dwSWCurPointer += 4;
            }
            dwStart = pddAGP->AGPBasePHYSADD;
            dwEnd   = pddAGP->AGPBasePHYSADD + MPEG_AGP_CMDBUF_SIZE - 1;
            dwPause = pddAGP->AGPBasePHYSADD + (dwSWCurPointer - gdwAGPBaseVirtual) - 4;
            /* AGP command buffer setting register*/
            dwBstL  = (dwStart & 0x00FFFFFF) | 0x60000000;
            dwBendL = (dwEnd   & 0x00FFFFFF) | 0x61000000;
            dwCMNT  = (dwStart >> 24) | ((dwEnd & 0xFF000000 ) >> 16)  | 0x62000000;
            dwBpL   = (dwPause & 0x00FFFFFF) | 0x63000000;
            dwBpH   = (dwPause >> 24 ) | 0x64000000;

            VIDOutD(0x43C,0x00100000);
            VIDOutD(0x440,dwCMNT);
            VIDOutD(0x440,dwBstL);
            VIDOutD(0x440,dwBendL);
            VIDOutD(0x440,dwBpH);
            VIDOutD(0x440,dwBpL);
            /* Fetch Command*/
            VIDOutD(0x440,dwCMNT | 0x00800000);
        }       
    }	 

    if (pddAGP->dwCmdBufType  == AGPCMDBUF_DISABLE) 
    {
        DBG_DD(("AGPCMDBUF_DISABLE, null\n"));
        fpSwapAGPCmdBuffer = SwapAGPCmd_Null;
    }
    else if(drm_fd > 0)
    {
        fpSwapAGPCmdBuffer = SwapAGPCmd_DRM;
    }
    else
    {
        if (pddAGP->dwCmdBufType  == AGPCMDBUF_RING) 
        {
            DBG_DD(("AGPCMDBUF_RING\n"));
            fpSwapAGPCmdBuffer = SwapAGPCmd_Ring;
        }
        else 
        {
            DBG_DD(("SwapAGPCmd_DB\n"));
            fpSwapAGPCmdBuffer = SwapAGPCmd_DB;
        }
    }
    pWknAGP->dwFlag |= AGP_DD_INITIALIZED ;

    DBG_DD(("agpPhysical=0x%x,agpLinear=%p\n   cmdbuf[0].start=%p,cmdbuf[0].end=%p\n   cmdbuf[1].start=%p,cmdbuf[1].end=%p\n",
                           pddAGP->AGPBasePHYSADD,gdwAGPBaseVirtual,
                           pddAGP->BufRec[0].Start_pointer,pddAGP->BufRec[0].End_pointer,
                           pddAGP->BufRec[1].Start_pointer,pddAGP->BufRec[1].End_pointer));
    return TRUE;       
}


int vfInitialAGPControl(PVIDDATA pVidData)
{
    DBG_DD(("vfInitialAGPControl \n"));

	if(!DDInitialAGPControl(pVidData))
		return FALSE;
    
    if (pddAGP->dwFlag & AGPSTATUS_CMDBUF_ALLOCATED)
    {/*Only Inc AGP Count*/
        DDIncVIDEOAGPCount(pVidData);
        pVidData->VidAGPCtl.dwVIdeoAGPUseNum++;
        DBG_DD(("dwVIdeoAGPUseNum=%d\n",pVidData->VidAGPCtl.dwVIdeoAGPUseNum));

        return TRUE;
    }
    else  
        return FALSE;
}

unsigned long* vfRequestAGPbuffer(PVIDDATA pVidData,unsigned long dwAGPHeaderType,unsigned long dwHeader5Reg)
{    
    DBG_DD(("// vfRequestAGPbuffer -"));
    if (pVidData->VidAGPCtl.dwAGPRequest==1)
    {
        DBG_DD(("  fireAGPcommand\n"));
        vfFireAGPcommand(pVidData);
    }

    if(pddAGP->dwFlag&AGPSTATUS_CMDBUF_ALLOCATED) 
    {
        pVidData->VidAGPCtl.dwAGPHeaderType=dwAGPHeaderType;
        pVidData->VidAGPCtl.dwAGPCMCount=0;
        pVidData->VidAGPCtl.dwAGPRequest=1;
        /*Buffer size to request is unknown, use same size as 2D/3D PCICmdBuf.*/
        pVidData->VidAGPCtl.dwAGPSt_Pointer= RequestAGPCmdBufSize(pVidData,pddAGP,AGP_REQUEST_2D_BUFFER_SIZE); 
        DBG_DD(("dwAGPSt_Pointer=%p -",pVidData->VidAGPCtl.dwAGPSt_Pointer));

        pVidData->VidAGPCtl.dwAGPCurr_Pointer=pVidData->VidAGPCtl.dwAGPSt_Pointer;
        switch (dwAGPHeaderType)
        {
        case VIDEO_AGPHeader5:
	        DBG_DD(("VIDEO_AGPHeader5 -"));
            pVidData->VidAGPCtl.dwAGPH5Reg=dwHeader5Reg;
            pVidData->VidAGPCtl.dwAGPCurr_Pointer+=16;
            break;
        case VIDEO_AGPHeader6:
	        DBG_DD(("VIDEO_AGPHeader6 -"));
            pVidData->VidAGPCtl.dwAGPCurr_Pointer+=16;
            break;
        case VIDEO_AGPHeader7:
	        DBG_DD(("VIDEO_AGPHeader7 -"));
            break;
        default:
            break;
        }
        DBG_DD(("dwAGPCurr_Pointer=%p\n",pVidData->VidAGPCtl.dwAGPCurr_Pointer));
        return (unsigned long *)pVidData->VidAGPCtl.dwAGPCurr_Pointer;
    }
    else    /*PCI burst.*/
    {
        pVidData->VidAGPCtl.dwAGPHeaderType=dwAGPHeaderType;
        pVidData->VidAGPCtl.dwAGPCMCount=0;
        pVidData->VidAGPCtl.dwAGPRequest=1;
        switch (dwAGPHeaderType)
        {
        case VIDEO_AGPHeader5:
            pVidData->VidAGPCtl.dwAGPH5Reg=dwHeader5Reg;
            pVidData->VidAGPCtl.lpAGPCurr_buffer=pVidData->VidAGPCtl.lpAGPSt_buffer + 16;
            break;
        case VIDEO_AGPHeader6:
            pVidData->VidAGPCtl.lpAGPCurr_buffer=pVidData->VidAGPCtl.lpAGPSt_buffer + 16;
            break;
        case VIDEO_AGPHeader7:
            pVidData->VidAGPCtl.lpAGPCurr_buffer=pVidData->VidAGPCtl.lpAGPSt_buffer;
            break;
        default:
            break;
        }
    
        return pVidData->VidAGPCtl.lpAGPCurr_buffer;
    }
}

void vfCMAGP(unsigned long dwIndex,unsigned long dwData,PVIDDATA pVidData)
{
    unsigned long * lpAGPbuffer;
    unsigned long dwAGPHeaderType   = pVidData->VidAGPCtl.dwAGPHeaderType;
    unsigned long *       lpAGPSt_buffer;
    unsigned long *       lpAGPCurr_buffer;


    if (pVidData->VidAGPCtl.dwAGPRequest == 0)
    {
        DBG_DD(("vfCMAGP():The AGP command buffer is not requested!  "));
        return;
    }
    if (pddAGP->dwFlag&AGPSTATUS_CMDBUF_ALLOCATED)
    {
        lpAGPSt_buffer = (unsigned long *)(pVidData->VidAGPCtl.dwAGPSt_Pointer+gdwAGPBaseVirtual);
        lpAGPCurr_buffer = (unsigned long *)(pVidData->VidAGPCtl.dwAGPCurr_Pointer+gdwAGPBaseVirtual);
        if (lpAGPCurr_buffer>=(lpAGPSt_buffer+AGP_REQUEST_2D_BUFFER_SIZE-4))
        {
            DBG_DD(( "Video AGP command out of requested cmd. buffer range!"));
            vfFireAGPcommand(pVidData);
            vfRequestAGPbuffer(pVidData, dwAGPHeaderType, 0);
        }
        lpAGPbuffer= (unsigned long *)(pVidData->VidAGPCtl.dwAGPCurr_Pointer+gdwAGPBaseVirtual);
        switch (dwAGPHeaderType)
        {
        case VIDEO_AGPHeader5:
            *lpAGPbuffer++=dwData;
            pVidData->VidAGPCtl.dwAGPCMCount++;
            break;
        case VIDEO_AGPHeader6:
        case VIDEO_AGPHeader7:
            *lpAGPbuffer++=dwIndex;
            *lpAGPbuffer++=dwData;
            pVidData->VidAGPCtl.dwAGPCMCount++;
            break;
        default:
            break;
        }
        pVidData->VidAGPCtl.dwAGPCurr_Pointer=((unsigned long)lpAGPbuffer)-gdwAGPBaseVirtual;
    }
    else    /*PCI burst.*/
    {
        lpAGPbuffer=(unsigned long *)pVidData->VidAGPCtl.lpAGPCurr_buffer;
        switch (dwAGPHeaderType)
        {
        case VIDEO_AGPHeader5:
            *lpAGPbuffer++=dwData;
            pVidData->VidAGPCtl.dwAGPCMCount++;
            break;
        case VIDEO_AGPHeader6:
        case VIDEO_AGPHeader7:
            *lpAGPbuffer++=dwIndex;
            *lpAGPbuffer++=dwData;
            pVidData->VidAGPCtl.dwAGPCMCount++;
            break;
        default:
            break;
        }
        pVidData->VidAGPCtl.dwAGPCurr_Pointer= ((unsigned long)lpAGPbuffer)-gdwAGPBaseVirtual;
    }
}

void vfFireAGPcommand(PVIDDATA pVidData)
{
    LPVIDEOHWINFO lphwinfo        =&pVidData->Vhwinfo;
    unsigned long         dwAGPHeaderType =pVidData->VidAGPCtl.dwAGPHeaderType;
    unsigned long         dwAGPCMCount    =pVidData->VidAGPCtl.dwAGPCMCount;
    unsigned long *       lpAGPSt_buffer;
    unsigned long *       lpAGPCurr_buffer;
    unsigned long         dwRegPCI800     =0x800;
    unsigned long         dwRegPCIAGPBurst=0x800;
    unsigned long * lpAGPCmdIndex;
    unsigned long         i=0;

    pVidData->VidAGPCtl.dwAGPRequest=0;   
    DBG_DD(("\n"));
    if (dwAGPCMCount==0)
    {
        DBG_DD(( "Video AGP command fire 0 command!"));
        return;
    }

    if (pddAGP->dwFlag & AGPSTATUS_CMDBUF_ALLOCATED)
    {
        lpAGPSt_buffer = (unsigned long *)(pVidData->VidAGPCtl.dwAGPSt_Pointer+gdwAGPBaseVirtual);
        lpAGPCurr_buffer = (unsigned long *)(pVidData->VidAGPCtl.dwAGPCurr_Pointer+gdwAGPBaseVirtual);
        lpAGPCmdIndex=lpAGPSt_buffer;
        	
        switch (dwAGPHeaderType)
        {
        case VIDEO_AGPHeader5:
            /*Insert header data.*/
            DBG_DD((" VIDEO_AGPHeader5 - dwAGPCMCount - %ld\n",dwAGPCMCount));
            lpAGPSt_buffer[0]=VIDEO_AGPHeader5|pVidData->VidAGPCtl.dwAGPH5Reg;
            lpAGPSt_buffer[1]=dwAGPCMCount;
            lpAGPSt_buffer[2]=0x00F50000;   /*SW debug flag.*/
            lpAGPSt_buffer[3]=0;
            /*128bits alignment*/
            if (dwAGPCMCount%4)
            {
                DBG_DD(("Video AGP command VIDEO_AGPHeader5 is not 128 bits alignment! "));
                for (i=0; i<(4-(dwAGPCMCount%4)); i++)
                {
                    *lpAGPCurr_buffer++=0x000000000;
                    pVidData->VidAGPCtl.dwAGPCMCount++;
                }
            }
            break;
        case VIDEO_AGPHeader6:
	        DBG_DD((" VIDEO_AGPHeader6 - dwAGPCMCount- %ld\n",dwAGPCMCount));
            /*Insert header data.*/
            lpAGPSt_buffer[0]=VIDEO_AGPHeader6;
            lpAGPSt_buffer[1]=dwAGPCMCount;
            lpAGPSt_buffer[2]=0x00F60000; /*SW debug flag*/
            lpAGPSt_buffer[3]=0;
            
            if (dwAGPCMCount%2)
            {
                *lpAGPCurr_buffer++=0x00000000;
                *lpAGPCurr_buffer++=0x00000000;
                pVidData->VidAGPCtl.dwAGPCMCount++;
            }
            break;
        case VIDEO_AGPHeader7:
            /*For header 7 case, count of command must be even.*/
            DBG_DD((" VIDEO_AGPHeader7 - dwAGPCMCount=%ld\n",dwAGPCMCount));
            if (dwAGPCMCount%2)
            {
                *lpAGPCurr_buffer++=(REG_VIDEO_NULL_12A0|0x00F70000);   /*Null command addr.*/
                *lpAGPCurr_buffer++=0;  /*Null command data.*/
                pVidData->VidAGPCtl.dwAGPCurr_Pointer= (unsigned long)lpAGPCurr_buffer-gdwAGPBaseVirtual;
                dwAGPCMCount++;
                pVidData->VidAGPCtl.dwAGPCMCount=dwAGPCMCount;
            }
            /*Header data and SW flag*/
            for (i=0; i<(dwAGPCMCount/2); i++)
            {
                /*Add header data to high byte and keep first command addr. at low byte.*/
                (*lpAGPCmdIndex++)|=VIDEO_AGPHeader7; 
                /*Keep first command data.*/
                lpAGPCmdIndex++;   
                /*Add SW flag to high byte and keep second command addr. at low byte.*/
                (*lpAGPCmdIndex++)|=0x00F70000; 
                /*Keep second command data.*/
                lpAGPCmdIndex++;   
            }
            break;
        default:
            break;
        }
        /*Set current pointer and fire command.*/
        pddAGP->dwFlag &= ~AGPSTATUS_CMDBUF_LOCK;
        pddAGP->dwSWCurPointer = (unsigned long)lpAGPCurr_buffer-gdwAGPBaseVirtual;
        fpSwapAGPCmdBuffer(pddAGP,pVidData);
    }
    else    /*PCI burst.*/
    {
        lpAGPSt_buffer=(unsigned long *)pVidData->VidAGPCtl.lpAGPSt_buffer;
        lpAGPCurr_buffer=(unsigned long *)pVidData->VidAGPCtl.lpAGPCurr_buffer;
        if (lpAGPCurr_buffer>=(lpAGPSt_buffer+VAL_VIDEO_AGP_BUFFER_SIZE))
        {
            DBG_DD(("Video AGP command out of requested 2D buffer range!"));
        }
        lpAGPCmdIndex=lpAGPSt_buffer;

        switch (dwAGPHeaderType)
        {
        case VIDEO_AGPHeader5:
            lpAGPSt_buffer[0]=VIDEO_AGPHeader5|pVidData->VidAGPCtl.dwAGPH5Reg;
            lpAGPSt_buffer[1]=dwAGPCMCount;
            lpAGPSt_buffer[2]=0x00F50000; /*SW debug flag*/
            lpAGPSt_buffer[3]=0;
            /*AGP 128 bits header*/
            for (i=0; i<4; i++)
            {
                dMMWR(lphwinfo->pjVideo, (dwRegPCI800+i*4), *lpAGPSt_buffer++);
            }
        
            for (i=0; i<dwAGPCMCount; i++)
            {
                dwRegPCIAGPBurst=dwRegPCI800+(i%64)*4;
                dMMWR(lphwinfo->pjVideo, dwRegPCIAGPBurst, *lpAGPSt_buffer++); /*Data*/          
            }        
        
            /*128 bits alignment*/
            if (dwAGPCMCount%4)
            {
                DBG_DD(("Video AGP command VIDEO_AGPHeader5 is not 128 bits alignment! "));
                for (i=0; i<(4-(dwAGPCMCount%4)); i++)
                {
                    dMMWR(lphwinfo->pjVideo, dwRegPCIAGPBurst, 0x00000000); /*Add zero value.*/
                }
            }
            break;
        case VIDEO_AGPHeader6:
            lpAGPSt_buffer[0]=VIDEO_AGPHeader6;
            lpAGPSt_buffer[1]=dwAGPCMCount;
            lpAGPSt_buffer[2]=0x00F60000; /*SW debug flag*/
            lpAGPSt_buffer[3]=0;
            /*AGP 128 bits header*/
            for (i=0; i<4; i++)
            {
                dMMWR(lphwinfo->pjVideo, (dwRegPCI800+i*4), *lpAGPSt_buffer++);
            }

            for (i=0; i<dwAGPCMCount; i++)
            {
                dwRegPCIAGPBurst=dwRegPCI800+(i%64)*8;
                dMMWR(lphwinfo->pjVideo, dwRegPCIAGPBurst, *lpAGPSt_buffer++); /*I/O address*/
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst+4), *lpAGPSt_buffer++); /*Data*/      
            }        
            if (dwAGPCMCount%2)
            {
                dMMWR(lphwinfo->pjVideo, dwRegPCIAGPBurst, 0x00000000); /*Add zero value.*/            
                dMMWR(lphwinfo->pjVideo, dwRegPCIAGPBurst, 0x00000000); /*Add zero value.*/            
            }
            break;
        case VIDEO_AGPHeader7:
            for (i=0; i<(dwAGPCMCount/2); i++)
            {
                dwRegPCIAGPBurst=dwRegPCI800+(i%32)*16;
                dMMWR(lphwinfo->pjVideo, dwRegPCIAGPBurst, (*lpAGPSt_buffer++|VIDEO_AGPHeader7)); /*I/O address*/
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst+4), *lpAGPSt_buffer++); /*Data*/      
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst+8), (*lpAGPSt_buffer++|0x00F70000)); /*I/O address and SW debug flag*/
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst+12), *lpAGPSt_buffer++); /*Data*/      
            }            
    
            if (dwAGPCMCount%2)
            {
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst), (*lpAGPSt_buffer++|VIDEO_AGPHeader7)); /*I/O address*/
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst+4), *lpAGPSt_buffer++); /*Data*/      
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst+8), (REG_VIDEO_NULL_12A0|0x00F70000)); /*I/O address and SW debug flag*/
                dMMWR(lphwinfo->pjVideo, (dwRegPCIAGPBurst+12), 0); /*Data*/      
            }
        default:
            break;
        }    
    }
  
}

void vfReleaseAGPControl(PVIDDATA pVidData)
{  
    DDDecVIDEOAGPCount(pVidData);
    pVidData->VidAGPCtl.dwVIdeoAGPUseNum--; 
    DBG_DD(("vfReleaseAGPControl dwVIdeoAGPUseNum=%d\n",pVidData->VidAGPCtl.dwVIdeoAGPUseNum));

    if (drm_fd>0)
    {
        if ( gdwOrigAGPBaseVirtual != 0 )
        {
            munmap( (void *)gdwOrigAGPBaseVirtual , drm_info.AgpSize);
            gdwOrigAGPBaseVirtual = 0;
        }
        ioctl(drm_fd,DRM_IOCTL_VIA_FREEMEM,&AgpMem); 
    }
    else if  (gartFd)
    {
        agp_info info;

        if(ioctl(gartFd, AGPIOC_INFO, &info) != 0)
        {
            DBG_DD(("ioctl(AGPIOC_INFO) fail"));
            return ;
        }
        DBG_DD(("[no drm] agp info.aper_size = %d\n",info.aper_size ));

        if ( gdwAGPBaseVirtual != -1 )
        {
            munmap((void *)gdwAGPBaseVirtual , info.aper_size*0x100000);
            gdwAGPBaseVirtual = -1;
        }

        remove_gart(agpgartkey);      
        DBG_DD(("Using AGPIOC_RELEASE\n"));

        if(ioctl(gartFd, AGPIOC_RELEASE,0) != 0)
        {
            DBG_DD(("ioctl(AGPIOC_RELEASE) fail"));
            return;
        }        
        close(gartFd);
        close(mtrr);
    }

    if (pVidData->VidAGPCtl.dwVIdeoAGPUseNum==0)
    {
        pVidData->VidAGPCtl.lpAGPSt_buffer = NULL;
        pVidData->VidAGPCtl.lpAGPCurr_buffer=NULL;    
        pVidData->VidAGPCtl.dwAGPSt_Pointer=0;
        pVidData->VidAGPCtl.dwAGPCurr_Pointer = 0;
        pVidData->VidAGPCtl.dwAGPCMCount=0;
        pVidData->VidAGPCtl.dwAGPHeaderType=VIDEO_AGPHeader7;
        pVidData->VidAGPCtl.dwAGPH5Reg=REG_VIDEO_NULL_12A0; 
         
        pddAGP->dwRegBase =  NULL;	 	
        pddAGP->dwCmdBufSize = 0;
        pddAGP->dwCmdBufBegin = 0;
        pddAGP->dwCmdBufEnd = 0;	   
        pddAGP->BufRec[0].Start_pointer = 0;
        pddAGP->BufRec[0].End_pointer = 0;
        pddAGP->BufRec[1].Start_pointer = 0;
        pddAGP->BufRec[1].End_pointer = 0 ;	 
        pddAGP->pHWAGPCur = NULL;
        pddAGP->dwHWCaps = 0;
    
        pddAGP->dwLastPause = 0;
        pddAGP->dwSWCurPointer = 0;	
        pddAGP->dwRewindCount = 0;        
        pddAGP->dwFlag = 0;	 
    }
}
