 /*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
 

/* dwCtlMPEGFlag, MPEG control flag */
#define CTL_MPG_DUAL_ENABLE_CME                 0x00100000
#define CTL_MPG_TILEMODE_ENABLE_CME             0x00000001
#define CTL_MPG_TILEMODE_512BITS_CME            0x00000002
#define CTL_MPG_TILEMODE_256BITS_CME            0x00000000
#define CTL_MPG_USE_MPEG_ENGINE0_CME            0x00000000
#define CTL_MPG_USE_MPEG_ENGINE1_CME            0x00000010
#define CTL_MPG_RESET_ENABLE_CME                0x00000100
#define CTL_MPG_PATCH_USE_ZIGZAGSCANMETHOD_CME  0x00001000
#define CTL_MPG_USE_DXVA_PROPRIETARY_MC_CME     0x00010000

/* dwCtlHQVflag, HQV control flag */
#define CTL_HQV_TILEMODE_ENABLE_CME             0x00000001
#define CTL_HQV_TILEMODE_512BITS_CME            0x00000002
#define CTL_HQV_TILEMODE_256BITS_CME            0x00000000
#define CTL_HQV_CSC_ENABLE_CME                  0x00000010
#define CTL_HQV_CSC_RGB32_CME                   0x00000040
#define CTL_HQV_CSC_RGB16_CME                   0x00000020
/* For VT3264 */
#define CTL_HQV_CSC_RGB101010_CME2              0x00000080
#define CTL_HQV_SCALING_UP_ENABLE_CME           0x00000100
#define CTL_HQV_DEINTERLACE_ENABLE_CME          0x00001000
#define CTL_HQV_3to2PULLDOWN_ENABLE_CME         0x00002000
#define CTL_HQV_CAPTURE_DEINTERLACE_ENABLE_CME  0x00010000
/* For VT3264 */
#define CTL_HQV_OUTPUT_V410_CME2                0x00100000
#define CTL_HQV_OUTPUT_TILE_CME2                0x00200000
#define CTL_HQV_USE_V3_CSC_CME2                 0x00400000
#define CTL_HQV_ALPHAWINDOW_ENABLE_CME          0x10000000
#define CTL_HQV_ALPHAWINDOW_STREAM_CME          0x00000000
#define CTL_HQV_ALPHAWINDOW_GRAPHIC_CME         0x20000000
/* For VT3264 FPGA test */
#define CTL_HQV_SINGLE_BUFFER_CME               0x01000000
#define CTL_HQV_DOUBLE_BUFFER_CME               0x02000000
/* S3Chromo-De-blocking setting */
#define CTL_HQV_TVFIELDSYNC_ENABLE              0x40000000
#define CTL_HQV_TV_ON_ADD_BUS                   0x80000000
/* S3Chromo-De-blocking setting */
#define VAL_HQV_DEBLOCKING_ENABLE               0x08000000
#define VAL_HQV_TVFIELDSYNC_ENABLE              0x00004000
#define VAL_HQV_TV_ON_ADD_BUS                   0x00000800

/* for VT3293 HQV Scale*/
#define HQV_H_SCALE_ENABLE                      0x80000000
#define HQV_H_SCALE_UP                          0x00000000  
#define HQV_H_SCALE_DOWN_FOURTH_TO_1            0x10000000 
#define HQV_H_SCALE_DOWN_FOURTH_TO_EIGHTH       0x20000000 
#define HQV_H_SCALE_DOWN_UNDER_EIGHTH           0x30000000 
  
#define HQV_V_SCALE_ENABLE                      0x80000000
#define HQV_V_SCALE_UP                          0x00000000
#define HQV_V_SCALE_DOWN                        0x10000000


/* HQV engine value */
/* for VT3259 Video Rotation */
#define VAL_HQV_SINGLE_BUFF_CME                 0x00000040
#define VAL_HQV_TILEMODE_512BITS_CME            0xc0000000
#define VAL_HQV_TILEMODE_256BITS_CME            0x80000000
#define VAL_HQV_CSC_ENABLE_CME                  0x10000000
#define VAL_HQV_CSC_RGB32_CME                   0x20000000
#define VAL_HQV_CSC_RGB16_CME                   0x00000000
#define VAL_HQV_GAMMA_ENABLE_CME                0x02000000
#define VAL_HQV_H_DOWN_SCALE_CME                0x00001000
#define VAL_HQV_H_UP_SCALE_CME                  0x00000800
#define VAL_HQV_V_DOWN_SCALE_CME                0x10000000
#define VAL_HQV_V_UP_SCALE_CME                  0x08000000
/* for Vt3264 */
#define VAL_HQV_CSC_RGB101010_CME2              0x80000000
#define VAL_HQV_OUTPUT_TILE_CME2                0x40000000
#define VAL_HQV_USE_V3_CSC_CME2                 0x80000000

/* NEW HQV DE-INTERLACE DEFINITIONS */
#define VAL_PULL_DOWN_2_2_ENABLE_CME                        0x80000000
#define VAL_PULL_DOWN_INTER_FIELD_THRESHOLD_16_CME          0x40000000
#define VAL_PULL_DOWN_3_2_ENABLE_CME                        0x08000000
#define VAL_PULL_DOWN_INTRA_FIELD_THRESHOLD_FACTOR_2_CME    0x06000000
#define VAL_PULL_DOWN_FACTOR2_4_8_CME                       0x00040000
#define VAL_PULL_DOWN_FACTOR1_2_8_CME                       0x00000000
#define VAL_PULL_DOWN_MIN_THRESHOLD_2_CME                   0x00008000
#define VAL_HQV_MOTION_DETECTION_ENABLE_CME                 0x00001000
#define VAL_HQV_MOTION_THRESHOLD_16_CME                     0x00000800
#define VAL_HQV_EDGE_DETECTION_THRESHOLD_16_CME             0x00000010
#define VAL_HQV_EDGE_DETECTION_ENABLE_CME                   0x00000001
#define VAL_HQV_MOTIONADAPTIVE_ENABLE_CME                   0x00800000
#define VAL_HQV_V_2122_LOWPASS_FILTER_CME                   0x00200000
#define VAL_HQV_V_484_LOWPASS_FILTER_CME                    0x00400000
#define VAL_HQV_V_NO_LOWPASS_FILTER_CME                     0x00000000
#define VAL_HQV_OUTFIFO_THRESHOLD_32_CME                    0x00000000
#define VAL_HQV_FLIP_FIFODEPTH_1_CME                        0x00010000
#define VAL_HQV_FLIP_FIFODEPTH_1_BACK_DROP_CME              0x00030000
#define VAL_HQV_SW_FLIP_QUEUE_ENABLE_CME                    0x00100000
/* De-blocking */
#define VAL_DEBLOCK_ENABLE_CME                              0x08000000
#define VAL_DEBLOCK_LOWPASSFILTER_ENABLE_CME                0x04000000
#define VAL_DEBLOCK_MAX_62_CME                              0x000f0000

/* MPEG engine value */
#define VAL_MPG_TILEMODE_LINEAR_CME             0x00000000
#define VAL_MPG_TILEMODE_512BITS_CME            0x00003000
#define VAL_MPG_TILEMODE_256BITS_CME            0x00002000


/*****************************************************************************
*     VT3259 Video Control status                                           *
*                                                                           *
*****************************************************************************/
#define V1_SWAP_HW_CAPTURE0_CME                 0x04000000
#define V1_SWAP_HW_CAPTURE1_CME                 0x06000000

#define VAL_VIDEO_COLOR_KEY_ENABLE_CME          0x40000000
#define VAL_VIDEO_COLOR_KEY_INVERSE_CME         0x20000000
#define VAL_VIDEO_CHROMA_KEY_ENABLE_CME         0x40000000
#define VAL_VIDEO_CHROMA_KEY_INVERSE_CME        0x20000000
#define VAL_VIDEO_USE_V1_CHROMA_KEY_CME         0x00000000
#define VAL_VIDEO_USE_V3_CHROMA_KEY_CME         0x80000000

#define VAL_HM_WAIT_V1_FIRE                     0x00000010
#define VAL_HM_WAIT_V1_ADDRESS_LOAD             0x00000020
#define VAL_HM_WAIT_V1_HQV_FLIP_FIFO            0x00000008
#define VAL_HM_WAIT_V1_SUBFLIP                  0x00000004
#define VAL_HM_WAIT_V1_HQV_SW_FLIP              0x00000002
#define VAL_HM_WAIT_V1_HQV_DONE                 0x00000001
#define VAL_HM_WAIT_V3_FIRE                     0x00100000
#define VAL_HM_WAIT_V3_ADDRESS_LOAD             0x00200000
#define VAL_HM_WAIT_V3_HQV_FLIP_FIFO            0x00080000
#define VAL_HM_WAIT_V3_SUBFLIP                  0x00040000
#define VAL_HM_WAIT_V3_HQV_SW_FLIP              0x00020000
#define VAL_HM_WAIT_V3_HQV_DONE                 0x00010000

#define VIDEO_AGPHeader5                        0xFE040000
#define VIDEO_AGPHeader6                        0xFE050000
#define VIDEO_AGPHeader7                        0xFE060000



/*
* VT3259 VIDEO REGISTER VALUE DEFINITION
*/
/* V1/V3_CONTROL                   0x230,0x2a0 */
#define VAL_VIDEO_GAMMA_ENABLE_CME              0x20000000
#define VAL_VIDEO_SWAP_SW_CME                   0x00000000
#define VAL_VIDEO_SWAP_HW_HQV_CME               0x02000000
#define VAL_VIDEO_SWAP_HW_CAPTURE0_CME          0x04000000
#define VAL_VIDEO_SWAP_HW_CAPTURE1_CME          0x06000000
/* for VT3264*/
#define VAL_VIDEO_TILE_MODE                     0x08000000
#define VAL_VIDEO_EXPIRE_NUM_CME                0x00040000
#define VAL_VIDEO_EXPIRE_NUM_16_CME             0x00100000
#define VAL_VIDEO_EXPIRE_NUM_F_CME              0x000F0000
#define VAL_VIDEO_COLORSPACE_SIGN_CME           0x00000080
#define VAL_VIDEO_COLORSPACE_DISABLE_CME        0x00000100
#define VAL_VIDEO_FORMAT_YUV422_CME             0x00000000
#define VAL_VIDEO_FORMAT_RGB32_CME              0x00000004
#define VAL_VIDEO_FORMAT_RGB15_CME              0x00000008
#define VAL_VIDEO_FORMAT_RGB16_CME              0x0000000C
/* for VT3264 */
#define VAL_VIDEO_FORMAT_v410_CME2              0x00000010
#define VAL_VIDEO_FORMAT_RGB10_CME2             0x00000014
#define VAL_VIDEO_ENABLE_CME                    0x00000001

/* V_COMPOSE_MODE               0x298 */
#define VAL_DISABLE_LCD_VERTICAL_SCALING_CME    0x00000010
#define VAL_V1_COMMAND_ALWAYS_LOAD_CME          0x20000000  /* Video1 register always loaded */
#define VAL_V3_COMMAND_ALWAYS_LOAD_CME          0x08000000  /* Video3 register always loaded */
#define VAL_V1HDTV_CME                          0x01000000  /* Only V1 supports interpolation */
#define VAL_V3HDTV_CME                          0x02000000  /* Only V3 supports interpolation */


/* V1/V3_ZOOM_CONTROL              0x24C,0x2BC */
#define MASK_VIDEO_ZOOM_FACTOR_H                0xFFFF0000
#define MASK_VIDEO_ZOOM_FACTOR_V                0x0000FFFF

/* V1/V3 Buffer Starting Address 0   0x254, 0x2A4 */
#define SW_FLIP_ODD_CME2                        0x80000000

/* V1/V3/LCD_COLOR_KEY           0x220,0x280,0x264 */
#define VAL_VIDEO_COLOR_KEY_MASK                0x00FFFFFF

/* REG_HQV_TILE_CSC_CTL_CME                0x000003DC */
#define MASK_TILE_CSC_CME                       0x0FFFF800
#define MASK_HQV_IMAGE_SIZE_CME                 0x000007ff

/* HQV_SRC_FETCH_LINE    0x3e0 */
#define MASK_HQV_SRC_FETCH                      0x1FFF0000
#define VAL_HQV_SRC_FETCH_31                    0x001F0000

/* HQV_DST_STARTADDR0    0X3EC */
#define MASK_HQV_DST_ADDR                       0x1FFFFFFF

#define VAL_ColorSpaceValue_1_CME               0x13000DED
#define VAL_ColorSpaceValue_2_CME               0x13171000

/* CAPTURE0_CONTROL */
#define VAL_CAP_FLIPPING_CONTROL_ENABLE_CME     0x00008000


/* vfCommandManager,command function definiton */
#define CTL_CM_USE_V1_CME                       0x00010000
#define CTL_CM_USE_HQV_CME                      0x00100000
#define CTL_CM_USE_UseDuoView                   0x01000000

#define CTL_CM_UPDATEOVERLAY_CME                0x00000001
#define CTL_CM_SETPOSITION_CME                  0x00000002
#define CTL_CM_FLIP_CME                         0x00000004
#define CTL_CM_ESCUPDATEOVERLAY_CME             0x00000008
/* for VT3259 Video Rotation */
#define CTL_CM_ROTHQVPROCESS_CME                0x00000010
/* For VMR Path */
#ifdef DXVA_VMR_CME
#define CTL_CM_VMRHQV1CTL_CME                   0x00100000
#define CTL_CM_VMRHQV0CTL_CME                   0x00110000
#endif /* DXVA_VMR_CME */

#define CM_UPDATEOVERLAY_V1_CME                 0x00010001
#define CM_UPDATEOVERLAY_V3_CME                 0x00000001
#define CM_UPDATEOVERLAY_DuoView_CME            0x01000001
#define CM_UPDATEOVERLAY_V1_HQV_CME             0x00110001
#define CM_UPDATEOVERLAY_V1_HQV_DUOVIEW_CME     0x01110001 /*for DuoView*/
#define CM_UPDATEOVERLAY_V3_HQV_CME             0x00100001
#define CM_UPDATEOVERLAY_DuoView_HQV_CME        0x01100001
#define CM_SETPOSITION_V1_CME                   0x00010002
#define CM_SETPOSITION_V3_CME                   0x00000002
#define CM_SETPOSITION_V1_HQV_CME               0x00110002
#define CM_SETPOSITION_V3_HQV_CME               0x00100002
#define CM_SETPOSITION_DuoView_CME              0x01000002
#define CM_SETPOSITION_DuoView_HQV_CME          0x01100002
#define CM_FLIP_V1_CME                          0x00010004
#define CM_FLIP_V3_CME                          0x00000004
#define CM_FLIP_V1_HQV_CME                      0x00110004
#define CM_FLIP_V3_HQV_CME                      0x00100004
#define CM_ESCUPDATEOVERLAY_V1_CME              0x00010008
#define CM_ESCUPDATEOVERLAY_V3_CME              0x00000008
#define CM_ESCUPDATEOVERLAY_V1_HQV_CME          0x00110008
#define CM_ESCUPDATEOVERLAY_V3_HQV_CME          0x00100008
/* for VT3259 Video Rotation */
#define CM_ROTHQVPROCESS_CME                    0x00100010

/* dwFunSel,wait function definition */
#define HM_WAIT_FIRE                            0x00000001
#define HM_WAIT_SUBFLIP_FIRE                    0x00000002
#define HM_WAIT_SUBFLIP                         0x00000003
#define HM_WAIT_HQV_DONE                        0x00000004
#define HM_WAIT_HQVDONE_FIRE                    0x00000005
#define HW_WAIT_HQV_FIFOEMPTY                   0x00000006
#define HW_WAIT_HQV_FINISH                      0x00000007
#define HM_WAIT_3D_IDLE                         0x00000008
#define HM_WAIT_HQVDONE_FIRE_Rot                0x00000009
#define HM_WAIT_VQ_EMPTY                        0x0000000A
/* For Disable HQV Path */
#define HM_WAIT_HQVDONE_FIRE_DisableHQV         0x00000010

#define HM_WAIT_VIRTUAL_QUEUE                   0x00010000

#define HM_WAIT_FIRE_VQ                         0x00010001
#define HM_WAIT_SUBFLIP_FIRE_VQ                 0x00010002
#define HM_WAIT_SUBFLIP_VQ                      0x00010003
#define HM_WAIT_HQV_DONE_VQ                     0x00010004
#define HM_WAIT_HQVDONE_FIRE_VQ                 0x00010005
#define HW_WAIT_HQV_FIFOEMPTY_VQ                0x00010006
#define HW_WAIT_HQV_FINISH_VQ                   0x00010007
#define HM_WAIT_3D_IDLE_VQ                      0x00010008
#define HM_WAIT_HQVDONE_FIRE_VQ_Rot             0x00010009
#define HM_WAIT_VQ_EMPTY_VQ                     0x0001000A
/* For Disable HQV VQ Path */
#define HM_WAIT_HQVDONE_FIRE_DisableHQV_VQ      0x00010010

/* AGP definition */
#define VAL_VIDEO_AGP_BUFFER_SIZE               0x200000
#define VAL_VIDEO_AGP_SW_FLAG                   0xffff0000
#define ALLOC_TAG ALLOC_TAG_DDWN
/* for video commands using 2D/3D AGP cmd. buffer. */
#define AGP_REQUEST_2D_BUFFER_SIZE              0x80000

#define VAL_YUY2_BLACK_COLOR_CME                0x80008000

/* Video virtual queue definition */
#define VIDEO_VIRTUAL_QUEUE_SIZE                0x000080000 /* 512K bytes */

#define HW_ENABLE_VIDEO_VQ                      0x00000001
#define HVCMDQstL_Header                        (0x60 << 24 )
#define HVCMDQendL_Header                       (0x61 << 24 )
#define HVCMDQstendH_Header                     (0x62 << 24 )
#define HVCMDQLen_Header                        (0x63 << 24 )
#define HVCMDQSetting_Header                    (0x64 << 24 )

/* for VT3259 Video Rotation */
/* Rotation source & destination format definition */
#define VAL_ROTATION_RGB565                     0x00000000
#define VAL_ROTATION_RGB32                      0x00000001

/* Video/2D/3D Sync Method */
#define VIDCMDSTART                             0x00000000
#define VIDCMDEND                               0x10000000
#define VIDCMDEND_WAITMPG                       0x20000000
#define VIDCMDEND_WAITHQV                       0x30000000
