 /*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include <stdio.h>
#include "via_driver.h"
#include "via_regs.h"
#include "drm.h"
#include "agpctl.h"
unsigned long NULL_COMMAND_INV[4] = {0xCC000000, 0xCD000000, 0xCE000000, 0xCF000000};

void dump_agp_cmd(void* pbuf, int size)
{
    int i, *data = pbuf;
    for (i = 0; i < size; i += 16) {
        fprintf(stderr, "%04x:   ", i);
        fprintf(stderr, "%08x  ", *data++);
        fprintf(stderr, "%08x  ", *data++);
        fprintf(stderr, "%08x  ", *data++);
        fprintf(stderr, "%08x\n", *data++);
    }
    fprintf(stderr, "******************************************\n");;
}


void AddWaitCmdInv(volatile unsigned int ** ppCmd, unsigned int ChipID, unsigned int Flags)
{
    unsigned int cmd = 0;
    volatile unsigned int *pCmd;
    pCmd = *ppCmd;
    switch(ChipID)
    {
        case PCI_CHIP_VT3336:
        case PCI_CHIP_VT3364:
            {
                if(Flags & FLAG_WAIT_2D_IDLE)
                {
                    cmd |=UMA_HW_WAIT_2D_IDLE;
                }
                if(Flags & FLAG_WAIT_3D_IDLE)
                {
                    cmd |= UMA_HW_WAIT_3D_IDLE;
                }
                if(cmd)
                {
                    ADDCmdHeader4_INVI(pCmd, INV_REG_23D_WAIT, 1, 0);
                    *pCmd++ = cmd;
                    *pCmd++ = H5_HC_DUMMY;
                    *pCmd++ = H5_HC_DUMMY;
                    *pCmd++ = H5_HC_DUMMY;
                }
            }
            break;
        case PCI_CHIP_VT3353:
            {
                if(Flags & FLAG_WAIT_2D_IDLE)
                {
                    cmd |=INV_CR_WAIT_2D_IDLE;
                }
                if(Flags & FLAG_WAIT_3D_IDLE)
                {
                    cmd |= INV_CR_WAIT_3D_IDLE;
                }
                if(cmd)
                {
                    ADDCmdHeader0_INVI(pCmd, 1);
                    ADD2DCmd_INVI(pCmd, INV_CR_WAIT_ENGINE_IDLE,   cmd);
                    *pCmd++ = H5_HC_DUMMY;
                    *pCmd++ = H5_HC_DUMMY;
                }
            }
            break;
    }
    *ppCmd = pCmd;
}
