/*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/******************************Module*Header*******************************
* Module Name: VidInit.h
*
* Put all video function and parameters.
*
**************************************************************************/

#ifndef _VIDINIT_H
#define _VIDINIT_H

#ifdef XFree86Server
#include "via_video.h"  /* for viaPortPrivPtr struct */
#include "xf86fbman.h"  /* for FBLinearPtr */
#endif /* XFree86Server */
#include "VidStruc.h"   /* VIDDATA, video top level structure */
#include "via_memmgr.h" /* ViaMMReq structure */

/**************************************************************************
* Global Variable for Video function
**************************************************************************/


/**************************************************************************
* Extern Variable for Video function
**************************************************************************/
/* extern PVIDDATA pVidData; */


/**************************************************************************
* Extern function for Video function
**************************************************************************/


/**************************************************************************
* Defination for Video function
**************************************************************************/

/**************************************************************************
* Structure defination for Video function
**************************************************************************/

/*Wait Function Structure and Flag*/
typedef struct _WaitHWINFO
{
    unsigned char* pjVideo;				/*MMIO Address Info*/
    unsigned long dwVideoFlag;				/*Video Flag*/
}WaitHWINFO, * LPWaitHWINFO;


/**************************************************************************
* function defination for Video Driver
**************************************************************************/

unsigned long DispatchVGARevisionID(PVIDDATA pVidData);
Bool vfMapVideoFun(PVIDDATA pVidData);
void vfInitVideoInfo(PVIDDATA pVidData);
void vfInitHWDiff(PVIDDATA pVidData);
void MPEGFlipCurrentFrame(PVIDDATA pVidData);

/* VQ Control */
void vfEnable2DVQ(PVIDDATA pVidData);
void vfDisable2DVQ(PVIDDATA pVidData);

/* VQ Control for VT3259 */
void vfInitVideoVQ(PVIDDATA pVidData);
void vfEnableVQ_CME(PVIDDATA pVidData);
void vfDisableVQ_CME(PVIDDATA pVidData);

void vfEnableAGP_CME(PVIDDATA pVidData);
void vfDisableAGP_CME(PVIDDATA pVidData);

/*
 *  Function pointer for chips specific function assignment
 */
/* Video Function pointer declaration */
#ifdef LINUX_2_6
extern unsigned long (*fpFlip)(PVIDDATA pVidData, unsigned long DisplayBufferIndex);
#else
unsigned long (*fpFlip)(PVIDDATA pVidData, unsigned long DisplayBufferIndex);
#endif

#ifdef XFree86Server
unsigned long (*fpUpd_Video)(PVIDDATA pVidData);                 
unsigned long (*fpCreateSurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long (*fpDestroySurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
#elif LINUX_2_6
extern unsigned long (*fpUpd_Video)(PVIDDATA pVidData);                 
extern unsigned long (*fpCreateSurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
extern unsigned long (*fpDestroySurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
#endif /* XFree86Server */

#ifdef XFree86Server
/* CLE Video function declaration */
unsigned long Upd_Video(PVIDDATA pVidData);
unsigned long CreateSurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long Flip_CLE(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

/* CME Video function declaration */
unsigned long Upd_Video_CME(PVIDDATA pVidData);
unsigned long CreateSurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long Flip_CME(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

FBLinearPtr  XAllocFB(PVIDDATA pVidData, FBLinearPtr lpFBlinear, unsigned long dwFBsize);
#endif /* XFree86Server */

#endif    /* _VIDINIT_H */

