/*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef _VIA_LCD_H_
#define _VIA_LCD_H_ 1

struct LCD_POWER_SEQUENCE {
    CARD32  PanelSize;
    CARD32  TD0;
    CARD32  TD1;
    CARD32  TD2;
    CARD32  TD3;
};

struct LCD_POWER_SEQUENCE LCDPowerSeq[] = {
    /*     Panel Size           TD0    TD1   TD2    TD3      */
    {VIA_PANEL6X4,          200,    25,    0,    25},
    {VIA_PANEL8X6,          200,    25,    0,    25},
    {VIA_PANEL10X7,         200,    25,    0,    25},
    {VIA_PANEL12X7,         200,    25,    0,    25},
    {VIA_PANEL12X10,        200,    25,    0,    25},
    {VIA_PANEL14X10,        200,    25,    0,    25},
    {VIA_PANEL14X9,         200,    25,    0,    25},
    {VIA_PANEL12X8,         200,    25,    0,    25},
    {VIA_PANEL8X4,          200,    25,    0,    25},
    {VIA_PANEL8X4_GEN,      200,    25,    0,    25},
    {VIA_PANEL1366X7,       200,    25,    0,    25},
    {VIA_PANEL1360X7,       200,    25,    0,    25},
    {VIA_PANEL1920x1080,    200,    25,    0,    25},
    {VIA_PANEL1920x1200,    200,    25,    0,    25},
    {VIA_PANEL10X6,         200,    25,    0,    25},
    {VIA_PANEL16X12,        200,    25,    0,    25},
    {VIA_PANEL1280X720,     200,    25,    0,    25},
    {VIA_PANEL480X640,      200,    25,    0,    25}
};
#define NUM_TOTAL_POWER_SEQ ARRAY_SIZE(LCDPowerSeq)

void VIALoadLCDScaling(VIABIOSInfoPtr pBIOSInfo, int set_hres, int set_vres, int panel_hres, int panel_vres);
void VIALoadLCDPatchRegs(VIABIOSInfoPtr pBIOSInfo, int set_iga);
void VIA_load_lcd_k400_patch_tbl(VIABIOSInfoPtr pBIOSInfo);
void VIA_load_lcd_p880_patch_tbl(VIABIOSInfoPtr pBIOSInfo);
void VIASetLCDOutputPath(VIABIOSInfoPtr pBIOSInfo, int set_iga, int output_interface);
int VIAGetModeIndexByPanelSize(int PanelSizeID);
void VIA_fill_lcd_format(Bool bIsDualEdge, Bool bIsDithering);
Bool VIAPostLCDNotDVO(VIABIOSInfoPtr pBIOSInfo);
Bool VIAPostLCDDVO(VIABIOSInfoPtr pBIOSInfo);
Bool VIASetPanelState(VIABIOSInfoPtr pBIOSInfo, unsigned char state);
unsigned char VIAGetPanelState(VIABIOSInfoPtr pBIOSInfo);
void VIAEnableLCD(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo);
void VIADisableLCD(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo);
unsigned char VIAGetDeviceDetectLCD(VIABIOSInfoPtr pBIOSInfo);
void VIALCDSetMode(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo);
void VIAInitLCDDIPort(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo,unsigned char lcd2_flag);
Bool VIALVDSIdentify(VIABIOSInfoPtr pBIOSInfo);
Bool VIASetLCDPanelInfo(VIABIOSInfoPtr pBIOSInfo, int panel_id);
void VIAPreInit_LVDS(VIABIOSInfoPtr pBIOSInfo);
void VIALCDPatchSkew(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo);
void VIALoadScalingFactorForP4M900(VIABIOSInfoPtr pBIOSInfo, int set_hres, int set_vres, int panel_hres, int panel_vres);
void VIACheckDIPortOfIntegratedLVDS(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo);
void VIASWPowerSequenceON(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo);
void VIASWPowerSequenceOFF(VIABIOSInfoPtr pBIOSInfo, LVDSSETTINGINFOPTR pLVDSSettingInfo);
#endif  /* _VIA_LCD_H_ */


