/*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

 
/* Rotate Degree */
#define VIA_ROTATE_DEGREE_0       0
#define VIA_ROTATE_DEGREE_90      1
#define VIA_ROTATE_DEGREE_180     2
#define VIA_ROTATE_DEGREE_270     4
#define VIA_ROTATE_REFLECT_X      8
#define VIA_ROTATE_REFLECT_Y      16

#define VIA_ROTATE_TYPE_SW       0
#define VIA_ROTATE_TYPE_HW       1
#define VIA_ROTATE_TYPE_RANDR    2
#define VIA_ROTATE_TYPE_DYNAMIC  3  

void EnableDirectAccessWindow(ScrnInfoPtr pScrn);
void DisableDirectAccessWindow(ScrnInfoPtr pScrn);
void Enable2DEngineRotate(ScrnInfoPtr pScrn, CARD32* pGEMode, CARD32* pCommand);
void Enable2DEngineRotate_M1(ScrnInfoPtr pScrn, CARD32* pGEMode, CARD32* pCommand);
Bool IsSupportDirectAccessWindow(int ChipID);
Bool IsSupport2DRotateEngine(int ChipID);
void ProbeRotateCaps(ScrnInfoPtr pScrn);
void EnableDynamicRotate(ScrnInfoPtr pScrn); 
void ConvertCoordinatesOne(ScrnInfoPtr pScrn, int* X1, int* Y1, int w, int h);
void ConvertCoordinatesTwo(ScrnInfoPtr pScrn, int* X1, int* Y1, int* X2, int* Y2, int w, int h);
void ConvertDirection(ScrnInfoPtr pScrn, int xdir, int ydir, CARD32* cmd);
void ConvertSize(ScrnInfoPtr pScrn, int* width, int* height);
